﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OlaCudafy1.FDTD;

namespace OlaCudafy1.Test
{
	[TestClass]
	public class SourceTest
	{
		/// <summary>
		/// A test for Source Constructor
		/// </summary>
		[TestMethod]
		public void SourceConstructorTestRenamedForDebugging()
		{
			var sources = new[] {new Source(1, 1, 1, 1F, 1F),
				new Source(2, 2, 2, 2F, 2F), };

			const int newY = 33;
			const float newPA = 444F;

			sources[0].Mutate(y: newY);
			sources[1].Mutate(pressureAmplitude: newPA);

			var expected0 = new Source(1, newY, 1, 1F, 1F);
			var expected1 = new Source(2, 2, 2, 2F, newPA);

			Assert.AreEqual(expected0, sources[0]);
			Assert.AreEqual(expected1, sources[1]);
		}

		/// <summary>
		///A test for Source Constructor
		///</summary>
		[TestMethod()]
		public void SourceConstructorTest()
		{
			//Source target = new Source();
			//Assert.AreEqual(false, target.Enabled);
		}
	}
}
