struct KindExtent
{
	__device__ KindExtent()
	{
	}
	int X;
	int Y;
	int Z;
};



struct Point
{
	__device__ Point()
	{
	}
	int X;
	int Y;
	int Z;
	__device__ Point(int x, int y, int z)
	{
		X = x;
		Y = y;
		Z = z;
	}
	__device__ float Distance(Point other)
	{
		int num = X - other.X;
		int num2 = Y - other.Y;
		int num3 = Z - other.Z;
		return sqrtf((float)num * (float)num + (float)(num2 * num2) + (float)(num3 * num3));
	}
};



struct GridSettings
{
	__device__ GridSettings()
	{
	}
	float Boom;
	float CP;
	float CU;
	float DT;
	float DX;
	float FS;
	float GridMaxFreq;
	float GridNyquistFreq;
	int MinCellsPerWavelength;
	float MurCoefficient1;
	float MurCoefficient2;
	float MurCoefficient3;
	float _rmax;
	float R0;
	float Rk;
	float C0;
	float SoundPressure;
	float Impedance;
};



struct Source
{
	__device__ Source()
	{
	}
	int X;
	int Y;
	int Z;
	float Frequency;
	float PressureAmplitude;
	int InvokeAtGeneration;
	int Type;
	__device__ Source(int x, int y, int z, float frequency, float pressureAmplitude, int invokeAtGeneration, int type)
	{
		X = x;
		Y = y;
		Z = z;
		Frequency = frequency;
		PressureAmplitude = pressureAmplitude;
		InvokeAtGeneration = invokeAtGeneration;
		Type = type;
	}
};



struct MicrophoneStruct
{
	__device__ MicrophoneStruct()
	{
	}
	int X;
	int Y;
	int Z;
	__device__ MicrophoneStruct(int x, int y, int z)
	{
		X = x;
		Y = y;
		Z = z;
	}
};




// OlaCudafy1.FDTD.SimpleCalc
extern "C" __global__ void SimpleCalcKernel(float* p, int pLen0, int pLen1, int pLen2, float* horiz, int horizLen0, int horizLen1, int horizLen2, float* vert, int vertLen0, int vertLen1, int vertLen2, float* zSpeeds, int zSpeedsLen0, int zSpeedsLen1, int zSpeedsLen2, KindExtent ex, GridSettings* devGridAr, int devGridArLen0, unsigned char emulatingPart, Source* srcs, int srcsLen0, MicrophoneStruct* mics, int micsLen0, float* recordings, int recordingsLen0, int recordingsLen1, unsigned char* mat, int matLen0, int matLen1, int matLen2, unsigned char* adj, int adjLen0, int adjLen1, int adjLen2, float* abs, int absLen0, int generation);

// OlaCudafy1.FDTD.SimpleCalc
extern "C" __global__ void SimpleCalcKernel(float* p, int pLen0, int pLen1, int pLen2, float* horiz, int horizLen0, int horizLen1, int horizLen2, float* vert, int vertLen0, int vertLen1, int vertLen2, float* zSpeeds, int zSpeedsLen0, int zSpeedsLen1, int zSpeedsLen2, KindExtent ex, GridSettings* devGridAr, int devGridArLen0, unsigned char emulatingPart, Source* srcs, int srcsLen0, MicrophoneStruct* mics, int micsLen0, float* recordings, int recordingsLen0, int recordingsLen1, unsigned char* mat, int matLen0, int matLen1, int matLen2, unsigned char* adj, int adjLen0, int adjLen1, int adjLen2, float* abs, int absLen0, int generation)
{
	GridSettings gridSettings = devGridAr[(0)];
	int num = threadIdx.x + blockIdx.x * blockDim.x;
	int num2 = threadIdx.y + blockIdx.y * blockDim.y;
	if (num < ex.X && num2 < ex.Y)
	{
		float num3 = gridSettings.R0 * gridSettings.C0 * (1 + sqrtf(0.9)) / (1 - sqrtf(0.9));
		float num4 = 1 / gridSettings.CU;
		float num5 = (num4 - num3) / (num4 + num3);
		float num6 = 2 / (num4 + num3);
		if (emulatingPart == 0 || emulatingPart == 1)
		{
			for (int i = 0; i < ex.Z; i++)
			{
				unsigned char b = mat[(num) * matLen1 * matLen2 + ( num2) * matLen2 + ( i)] & 7;
				if (b == 0 || (num == 0 || num2 == 0) || i == 0)
				{
					if (num < ex.X - 1 && (mat[(num + 1) * matLen1 * matLen2 + ( num2) * matLen2 + ( i)] & 7) == 0)
					{
						horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] += gridSettings.CU * (((num > 0) ? 1 : 0) * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] - p[(num + 1) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)]);
					}
					else
					{
						if (num == ex.X - 1)
						{
							horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] += gridSettings.CU * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
						}
						else
						{
							if (num < ex.X - 1)
							{
								horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] = num5 * horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] + num6 * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
							}
						}
					}
					if (num2 < ex.Y - 1 && (mat[(num) * matLen1 * matLen2 + ( num2 + 1) * matLen2 + ( i)] & 7) == 0)
					{
						vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] += gridSettings.CU * (((num2 > 0) ? 1 : 0) * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] - p[(num) * pLen1 * pLen2 + ( num2 + 1) * pLen2 + ( i)]);
					}
					else
					{
						if (num2 == ex.Y - 1)
						{
							vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] += gridSettings.CU * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
						}
						else
						{
							if (num2 < ex.Y - 1)
							{
								vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] = num5 * vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] + num6 * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
							}
						}
					}
					if (i < ex.Z - 1 && (mat[(num) * matLen1 * matLen2 + ( num2) * matLen2 + ( i + 1)] & 7) == 0)
					{
						zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] += gridSettings.CU * (((i > 0) ? 1 : 0) * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] - p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i + 1)]);
					}
					else
					{
						if (i == ex.Z - 1)
						{
							zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] += gridSettings.CU * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
						}
						else
						{
							if (i < ex.Z - 1)
							{
								zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] = num5 * zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] + num6 * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
							}
						}
					}
				}
				else
				{
					if (num < ex.X - 1 && num2 < ex.Y - 1 && i < ex.Z - 1)
					{
						horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] = num5 * horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] - num6 * p[(num + 1) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
						vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] = num5 * vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)] - num6 * p[(num) * pLen1 * pLen2 + ( num2 + 1) * pLen2 + ( i)];
						zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] = num5 * zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)] - num6 * p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i + 1)];
					}
				}
			}
		}
		if (emulatingPart == 0)
		{
			__syncthreads();
		}
		if (emulatingPart == 0 || emulatingPart == 2)
		{
			for (int i = 0; i < ex.Z; i++)
			{
				if ((mat[(num) * matLen1 * matLen2 + ( num2) * matLen2 + ( i)] & 7) == 0)
				{
					if (num > 0 && num2 > 0 && i > 0)
					{
						p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] += gridSettings.CP * (horiz[(num - 1) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)] - horiz[(num) * horizLen1 * horizLen2 + ( num2) * horizLen2 + ( i)]);
						p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] += gridSettings.CP * (vert[(num) * vertLen1 * vertLen2 + ( num2 - 1) * vertLen2 + ( i)] - vert[(num) * vertLen1 * vertLen2 + ( num2) * vertLen2 + ( i)]);
						p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] += gridSettings.CP * (zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i - 1)] - zSpeeds[(num) * zSpeedsLen1 * zSpeedsLen2 + ( num2) * zSpeedsLen2 + ( i)]);
					}
				}
				else
				{
					p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] = 0;
				}
				int j = 0;
				while (j < srcsLen0)
				{
					Source source = srcs[(j)];
					if (source.InvokeAtGeneration == generation && source.Type == 0)
					{
						p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] = source.PressureAmplitude * expf(-(((float)(num - source.X) - 0.5) * gridSettings.DX * ((float)(num - source.X) - 0.5) * gridSettings.DX + ((float)(num2 - source.Y) - 0.5) * gridSettings.DX * ((float)(num2 - source.Y) - 0.5) * gridSettings.DX + ((float)(i - source.Z) - 0.5) * gridSettings.DX * ((float)(i - source.Z) - 0.5) * gridSettings.DX) / 0.02);
					}
					else
					{
						if (source.Type == 1)
						{
							if (num == source.X && num2 == source.Y && i == source.Z)
							{
								float num7 = (float)generation * gridSettings.DT;
								float num8 = 15 + gridSettings.GridMaxFreq * num7;
								float num9 = 2 * 3.141593 * num8;
								p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)] = source.PressureAmplitude * sinf(num9 * num7);
							}
						}
					}
					IL_72D:
					j++;
					continue;
					goto IL_72D;
				}
				for (int k = 0; k < micsLen0; k++)
				{
					MicrophoneStruct microphoneStruct = mics[(k)];
					if (num == microphoneStruct.X && num2 == microphoneStruct.Y && i == microphoneStruct.Z)
					{
						recordings[(k) * recordingsLen1 + ( generation)] = p[(num) * pLen1 * pLen2 + ( num2) * pLen2 + ( i)];
					}
				}
			}
		}
	}
}
