﻿namespace OlaCudafy1
{
	internal class AssocListItem
	{
		private readonly int _index;
		private readonly WallAbsorberAssociations _wallAbsorberAssociations;

		public AssocListItem(WallAbsorberAssociations wallAbsorberAssociations, int index)
		{
			_wallAbsorberAssociations = wallAbsorberAssociations;
			_index = index;
		}

		/// <summary>
		/// A material's index in the list, plus one
		/// </summary>
		public int MaterialNumber
		{
			get { return _index + 1; }
		}

		public string MaterialName
		{
			get { return _wallAbsorberAssociations.MaterialsArray[_index]; }
		}

		public string Absorber
		{
			get
			{
				WallAbsorberAssociations w = _wallAbsorberAssociations;
				if (w.AbsorberMappings[_index] == null)
					return null;
				return string.Format("d={0:0.00}, abs={1}",
				                     w.AbsorberMappings[_index].d,
				                     w.AbsorberMappings[_index].AbsorberCoefficients.ToBandCoefficients().Alpha125HzBand);
			}
		}
	}
}