using Cudafy;

namespace OlaCudafy1.FDTD
{
	static internal class Toolbox
	{
		public static int RoundUpDiv(int a, int b)
		{
			return (int)GMath.Ceiling((float)a / b);
		}

		public static float DecibelsRefSPL0ToPressure(float dB)
		{
			return GMath.Pow(10, dB/20f) * AirIntrinsicProperties.SPL0;
		}

		public static float PressureTodBrefSPL0(float pressureAmplitude)
		{
			return 20f*GMath.Log10(pressureAmplitude/AirIntrinsicProperties.SPL0);
		}

		internal static float DecibelsRef1ToPressure(float dB)
		{
			return GMath.Pow(10, dB / 20f);
		}
	}
}