﻿using Cudafy;

namespace OlaCudafy1
{
	[Cudafy]
	public struct KindExtent
	{
		public int X;
		public int Y;
		public int Z;

		/// <summary>
		/// Gets the 'flattened length' of the extent, i.e. X * Y * Z.
		/// Useful for comparing this object's 'length' with a multidimensional array's length,
		/// since those have a member for length, but contain no information about the
		/// lengths of the different dimensions.
		/// </summary>
		[CudafyIgnore]
		public int Length
		{
			get { return X*Y*Z; }
		}
	}
}