﻿using System.Collections.Generic;
using Cudafy;

namespace OlaCudafy1.Material
{
	internal class Cell
	{
		private Point _position;

		internal Point Position
		{
			get { return _position; }
			set { _position = value; }
		}


		public int MaterialIndex
		{
			get { return _materialIndex; }
			set { _materialIndex = value; }
		}

		/// <summary>
		/// For use in FDTD calc and draw, so that 0 can be air
		/// </summary>
		public byte MaterialByte
		{
			get { return (byte) (MaterialIndex+1); }
		}

		private int _materialIndex;

		public Cell(int x, int y, int z, int materialIndex)
		{
			_position = new Point(x, y, z);
			MaterialIndex = materialIndex;
		}

		public Cell(int materialIndex=0) : this(0, 0, 0, materialIndex)
		{
			
		}


	}
}