﻿using Cudafy;
using GASS.CUDA.Types;

namespace OlaCudafy1.Material
{
	[Cudafy]
	struct Point
	{
		public int X;
		public int Y;
		public int Z;

		public Point(int x, int y, int z)
		{
			X = x;
			Y = y;
			Z = z;
		}

		[CudafyIgnore]
		internal int this[int dimension]
		{
			set
			{
				switch (dimension)
				{
					case 0:
						X = value;
						break;
					case 1:
						Y = value;
						break;
					case 2:
						Z = value;
						break;
				}
			}
		}

		public float Distance(Point other)
		{
			int dx = X - other.X;
			int dy = Y - other.Y;
			int dz = Z - other.Z;
			return GMath.Sqrt((float) dx*dx + dy*dy + dz*dz);
		}


		[CudafyIgnore]
		internal Float3 ToGassCudaFloat3()
		{
			return new Float3 {x = X, y = Y, z = Z};
		}
	}
}