﻿using System.ComponentModel;
using System.Windows.Forms;

namespace OlaCudafy1
{
	public class MyListBox : ListBox
	{
		public new object DataSource
		{
			set
			{
				((ListBox) this).DataSource = value;
				((WallAbsorberAssociations) value).PropertyChanged += DataSource_PropertyChanged;
			}
		}

		private void DataSource_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			var selectedIndices = new int[SelectedIndices.Count];
			SelectedIndices.CopyTo(selectedIndices, 0);
			RefreshItems();
			// since selections are somewhat cleared when refreshing:
			ClearSelected();
			foreach (int selectedIndex in selectedIndices)
				SelectedIndices.Add(selectedIndex);
		}
	}
}