﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZedGraph;

namespace RoomModes
{
	class ModePointList : IPointList
	{
		private List<ModeTuple> _modeList;
		private PointPairList _pointPairList;

		public void Add(double x, double y, ModeTuple modeTuple)
		{
			_modeList.Add(modeTuple);
			_pointPairList.Add(x, y);
		}

		public int Count
		{
			get { return _pointPairList.Count; }
		}

		public PointPair this[int index]
		{
			get { return _pointPairList[index]; }
		}

		public string GetModeStringOf(int index)
		{
			ModeTuple m = _modeList[index];
			return m.ToString();
		}

		/// <summary>
		/// clone constructor
		/// </summary>
		/// <param name="rhs"></param>
		public ModePointList(ModePointList rhs)
		{
			_modeList = new List<ModeTuple>(rhs._modeList);
			_pointPairList = rhs._pointPairList.Clone();
			throw new NotImplementedException();
		}

		public ModePointList()
		{
			_modeList = new List<ModeTuple>();
			_pointPairList = new PointPairList();
		}

		public object Clone()
		{
			var m = new ModePointList(this);
			return m;
		}

	}
}
